/*
 * Copyright (c) 2008 - 2012, Andy Bierman, All Rights Reserved.
 * Copyright (c) 2012 - 2020, YumaWorks, Inc., All Rights Reserved.
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *

*** Generated by yangdump-sdk

    Combined SIL module
    module aio-test
    revision 2020-02-20
    namespace http://yumaworks.com/ns/aio-test
    CLI parameters:
        format c
        indent 4
        module aio-test
        output aio-test.c
        sil-edit2
        sil-get2
        unified true

 */

#include <xmlstring.h>

#include "procdefs.h"
#include "agt.h"
#include "agt_action.h"
#include "agt_cb.h"
#include "agt_cfg.h"
#include "agt_rpc.h"
#include "agt_sil_lib.h"
#include "agt_timer.h"
#include "agt_util.h"
#include "agt_val.h"
#include "cfg.h"
#include "dlq.h"
#include "getcb.h"
#include "ncx.h"
#include "ncx_feature.h"
#include "ncxmod.h"
#include "ncxtypes.h"
#include "obj.h"
#include "rpc.h"
#include "status.h"
#include "val.h"
#include "val_child.h"
#include "val_util.h"
#include "xml_val.h"
#include "aio-test.h"

/* module static variables */
static ncx_module_t *aio_test_mod;
static obj_template_t *get3_config_cont_obj;
static obj_template_t *get3_config_cont2_obj;
static val_value_t *get3_config_cont_val;
static val_value_t *get3_config_cont2_val;

/* put your static variables here */

/********************************************************************
* FUNCTION y_aio_test_init_static_vars
*
* initialize module static variables
*
********************************************************************/
static void y_aio_test_init_static_vars (void)
{
    aio_test_mod = NULL;
    get3_config_cont_obj = NULL;
    get3_config_cont2_obj = NULL;
    get3_config_cont_val = NULL;
    get3_config_cont2_val = NULL;

    /* init your static variables here */

} /* y_aio_test_init_static_vars */


/********************************************************************
* FUNCTION create_list_entry
*
* Make a list entry based on the key.
* Create the following subtree or as many nodes as found for the
* provided list object:
*
*
*     list nonconfig-list3 {
*       key name;
*       leaf name { type string; }
*       leaf not-keyname { type string; }
*
*        container int-con {
*          leaf int-con-leaf { type int32; }
*        }
*     }
*
* INPUTS:
*   res = return status
*
* RETURNS:
*    val_value_t of listval entry if no error
*    else NULL
*
*********************************************************************/
static val_value_t *
    create_list_entry (obj_template_t *list_obj,
                       const xmlChar *keyname,
                       const xmlChar *keystr,
                       status_t *res)
{
    /* find a key child obejct */
    obj_template_t *key_obj =
        obj_find_child(list_obj,
                       y_aio_test_M_aio_test,
                       keyname);
    if (!key_obj) {
        *res = ERR_NCX_INVALID_VALUE;
        return NULL;
    }

    val_value_t *list_value = val_new_value();
    if (!list_value) {
        *res = ERR_NCX_INVALID_VALUE;
        return NULL;
    }
    val_init_from_template(list_value, list_obj);

    /* make key leaf entry */
    val_value_t *child =
        val_make_simval_obj(key_obj,
                            keystr,
                            res);
    if (!child) {
        val_free_value(list_value);
        *res = ERR_NCX_INVALID_VALUE;
        return NULL;
    }

    *res = val_child_add(child, list_value);
    if (*res != NO_ERR) {
        val_free_value(child);
        val_free_value(list_value);
        return NULL;
    }

    obj_template_t *notkey_obj =
        obj_find_child(list_obj,
                       y_aio_test_M_aio_test,
                       (const xmlChar *)"not-keyname");
    if (notkey_obj) {
        /* make NON key leaf entry */
        child =
            val_make_simval_obj(notkey_obj,
                                (const xmlChar *)"some-value",
                                res);
        if (!child) {
            *res = ERR_NCX_INVALID_VALUE;
        }

        if (*res == NO_ERR) {
            *res = val_child_add(child, list_value);
            if (*res != NO_ERR) {
                val_free_value(child);
            }
        }
    }

    obj_template_t *cont_obj =
        obj_find_child(list_obj,
                       y_aio_test_M_aio_test,
                       (const xmlChar *)"int-con");
    if (cont_obj) {
        /* make return value that will be added to the return_aioQ */
        val_value_t *contval = val_new_value();
        if (!contval) {
            val_free_value(list_value);
            *res = ERR_NCX_INVALID_VALUE;
            return NULL;
        }
        val_init_from_template(contval, cont_obj);

        obj_template_t *leaf_obj =
            obj_find_child(cont_obj,
                           y_aio_test_M_aio_test,
                           (const xmlChar *)"con-leaf");
        if (leaf_obj) {
            val_value_t *leafval =
                val_make_simval_obj(leaf_obj,
                                    (const xmlChar *)"42",
                                    res);
            if (leafval) {
                *res = val_child_add(leafval, contval);
                if (*res != NO_ERR) {
                    val_free_value(leafval);
                    val_free_value(contval);
                }
            } else {
                val_free_value(contval);
                *res = ERR_NCX_INVALID_VALUE;
            }

            if (*res == NO_ERR) {
                *res = val_child_add(contval, list_value);
                if (*res != NO_ERR) {
                    val_free_value(contval);
                }
            }
        } else {
            val_free_value(contval);
        }
    }

    /* generate the internal index Q chain */
    *res = val_gen_index_chain(list_obj, list_value);
    if (*res != NO_ERR) {
        log_error("\nError: could not generate index chain (%s)",
                  get_error_string(*res));
        val_free_value(list_value);
        return NULL;
    }

    return list_value;

} /* create_list_entry */


/********************************************************************
* FUNCTION aio_test_get3_config_cont_config_list_nonconfig_list_nonconfig_list2_get
*
* Get database object callback for list nonconfig-list2
* Path: list /get3-config-cont/config-list/nonconfig-list/nonconfig-list2
* Fill in 'get2cb' response fields
*
* sil-aio-get2 extension enabled for this object;
* No callbacks for children will be called
*
* INPUTS:
*     see ncx/getcb.h for details (getcb_fn2_t)
*
* RETURNS:
*     error status
********************************************************************/
static status_t
    aio_test_get3_config_cont_config_list_nonconfig_list_nonconfig_list2_get (
        ses_cb_t *scb,
        xml_msg_hdr_t *msg,
        getcb_get2_t *get2cb)
{

    if (LOGDEBUG) {
        log_debug("\nEnter callback for /get3-config-cont/config-list/"
                  "nonconfig-list/nonconfig-list2");
    }

    (void)scb;
    (void)msg;

#if 0

    /* Use ancestor or local keys if needed */

    val_value_t *keyval = NULL;

    /* ancestor key aio-test:name */
    const xmlChar *k_get3_config_cont_config_list_name = 0;
    keyval = GETCB_GET2_FIRST_KEY(get2cb);
    if (keyval) {
        k_get3_config_cont_config_list_name = VAL_STRING(keyval);
    }

    /* ancestor key aio-test:name */
    const xmlChar *k_get3_config_cont_config_list_nonconfig_list_name = 0;
    keyval = GETCB_GET2_NEXT_KEY(get2cb, keyval);
    if (keyval) {
        k_get3_config_cont_config_list_nonconfig_list_name = VAL_STRING(keyval);
    }

    /* local key aio-test:name */
    const xmlChar *k_get3_config_cont_config_list_nonconfig_list_nonconfig_list2_name = 0;
    boolean name_fixed = FALSE;
    boolean name_present = FALSE;
    keyval =
        getcb_find_key_lvl(get2cb,
                           y_aio_test_M_aio_test,
                           y_aio_test_N_name,
                           (uint32)5);
    if (keyval) {
        k_get3_config_cont_config_list_nonconfig_list_nonconfig_list2_name = VAL_STRING(keyval);
        name_fixed = VAL_IS_FIXED_VALUE(keyval);
        name_present = TRUE;
    }

#endif

    obj_template_t *obj = GETCB_GET2_OBJ(get2cb);
    status_t res = NO_ERR;


    /* create 3 top level lists */
    uint32 key = 0;
    for (key = 1; key < 4; key++) {

        const xmlChar *key1 = NULL;
        if (key == (uint32)1) {
            key1 = (const xmlChar *)"name1";
        } else if (key == (uint32)2) {
            key1 = (const xmlChar *)"name2";
        } else if (key == (uint32)3) {
            key1 = (const xmlChar *)"name3";
        }

        /* make return value that will be added to the return_aioQ */
        val_value_t *retval = val_new_value();
        if (!retval) {
            return ERR_INTERNAL_MEM;
        }
        val_init_from_template(retval, obj);

        /* Use retval for the current callback obj and fill
         * it in with folowing terminal and complex nodes;
         * then add to get2cb with help of getcb_add_return_aioQ API
         */
        obj_template_t *childobj =
            getcb_first_requested_child(get2cb, obj);
        for (; childobj; childobj =
            getcb_next_requested_child(get2cb, childobj)) {

            const xmlChar *name = obj_get_name(childobj);

            /* Retrieve the value of this child node and
             * add it to retval of the current callback node
             */
            if (!xml_strcmp(name, (const xmlChar *)"name")) {
                /* leaf name (string) */
                val_value_t *child =
                    val_make_simval_obj(childobj,
                                        key1,
                                        &res);
                if (child) {
                    res = val_child_add(child, retval);
                    if (res != NO_ERR) {
                        val_free_value(child);
                        val_free_value(retval);
                        return ERR_NCX_INVALID_VALUE;
                    }
                } else {
                    val_free_value(retval);
                    return ERR_NCX_INVALID_VALUE;
                }
            } else if (!xml_strcmp(name, (const xmlChar *)"nonconfig-list3")) {

                /* list nonconfig-list3 (list) */
                uint32 nextlist_key = 0;
                for (nextlist_key = 1; nextlist_key < 3; nextlist_key++) {

                    const xmlChar *keyname = NULL;
                    if (nextlist_key == (uint32)1) {
                        keyname = (const xmlChar *)"name1";
                    } else if (nextlist_key == (uint32)2) {
                        keyname = (const xmlChar *)"name2";
                    }

                    /* create 5 list entries */
                    val_value_t *listval =
                        create_list_entry(childobj,
                                          (const xmlChar *)"name",
                                          keyname,
                                          &res);
                    if (!listval) {
                        val_free_value(retval);
                        return ERR_INTERNAL_MEM;
                    }

                    /* Use add_force to allow insertion lists with NO keys */
                    res = val_child_add(listval, retval);
                    if (res != NO_ERR) {
                        val_free_value(listval);
                        val_free_value(retval);
                        return ERR_NCX_INVALID_VALUE;
                    }
                }
            }
        }

        if (res == NO_ERR) {
            /* generate the internal index Q chain */
            res = val_gen_index_chain(obj, retval);
            if (res != NO_ERR) {
                val_free_value(retval);
                return res;
            }
        }

        /* Ensure that the generated value is correct and can be added
         * to the return Queue.
         */
        if (retval && res == NO_ERR) {
            res = val_validate_value(retval);
            if (res != NO_ERR) {
                val_free_value(retval);
                return res;
            }
        }

        /* Add created val_value_t to get2cb with help of
         * getcb_add_return_aioQ API; In case of list callbacks,
         * repeat above steps for another list entry
         */
        getcb_add_return_aioQ(get2cb, retval);
    }

    return res;

} /* aio_test_get3_config_cont_config_list_nonconfig_list_nonconfig_list2_get */


/********************************************************************
* FUNCTION aio_test_get3_config_cont_config_list_nonconfig_list_get
*
* Get database object callback for list nonconfig-list
* Path: list /get3-config-cont/config-list/nonconfig-list
* Fill in 'get2cb' response fields
*
* INPUTS:
*     see ncx/getcb.h for details (getcb_fn2_t)
*
* RETURNS:
*     error status
********************************************************************/
static status_t
    aio_test_get3_config_cont_config_list_nonconfig_list_get (
        ses_cb_t *scb,
        xml_msg_hdr_t *msg,
        getcb_get2_t *get2cb)
{

    if (LOGDEBUG) {
        log_debug("\nEnter aio_test_get3_config_cont_config_list_nonconfig_list_get");
    }

    (void)scb;
    (void)msg;

#if 0

    /* Use ancestor or local keys if needed */

    val_value_t *keyval = NULL;

    /* ancestor key aio-test:name */
    const xmlChar *k_get3_config_cont_config_list_name = 0;
    keyval = GETCB_GET2_FIRST_KEY(get2cb);
    if (keyval) {
        k_get3_config_cont_config_list_name = VAL_STRING(keyval);
    }

    /* local key aio-test:name */
    const xmlChar *k_get3_config_cont_config_list_nonconfig_list_name = 0;
    boolean name_fixed = FALSE;
    boolean name_present = FALSE;
    keyval =
        getcb_find_key_lvl(get2cb,
                           y_aio_test_M_aio_test,
                           y_aio_test_N_name,
                           (uint32)4);
    if (keyval) {
        k_get3_config_cont_config_list_nonconfig_list_name = VAL_STRING(keyval);
        name_fixed = VAL_IS_FIXED_VALUE(keyval);
        name_present = TRUE;
    }

#endif


    boolean getnext = FALSE;

    /* check the callback mode type */
    getcb_mode_t cbmode = GETCB_GET2_CBMODE(get2cb);
    switch (cbmode) {
    case GETCB_GET_VALUE:
        break;
    case GETCB_GETNEXT_VALUE:
        getnext = TRUE;
        break;
    default:
        return SET_ERROR(ERR_INTERNAL_VAL);
    }

    status_t res = NO_ERR;

    /* For GET, find the entry that matches the key values
     * For GETNEXT, find the entry that matches the next key value
     * If the 'present' flag is false then return first key instance
     * If the 'fixed' flag is true then no GETNEXT advance for the key
     * Create a new return key val_value_t, then getcb_add_return_key
     */

    /* get the list and child objects */
    obj_template_t *obj = GETCB_GET2_OBJ(get2cb);
    obj_template_t *name_obj =
        obj_find_child(obj,
                      y_aio_test_M_aio_test,
                      (const xmlChar *)"name");

    /* init leaf values for the get2-list */
    const xmlChar *name = NULL;
    const xmlChar *ret_name = NULL;
    boolean name_fixed = FALSE;

    /* check the keyQ for the specific list instance requested */
    val_value_t *name_key = getcb_find_key(get2cb, name_obj);

    /* pretend there are 3 values  */
#define NAME1 (const xmlChar *)"name1"
#define NAME2 (const xmlChar *)"name2"
#define NAME3 (const xmlChar *)"name3"

    if (name_key && VAL_STR(name_key)) {
        name = VAL_STR(name_key);
        int32 ret = xml_strcmp(name, NAME3);
        if (ret > 0) {
            return ERR_NCX_NO_INSTANCE;
        }
        name_fixed = VAL_IS_FIXED_VALUE(name_key);
    }

    boolean moreflag = TRUE;

    /* check validity of keys present */
    if (getnext) {
        if (name_fixed) {
            return ERR_NCX_NO_INSTANCE;
        }

        /* adjust the key to find the next entry after
         * the specified value
         */
        if (!name) {
            ret_name = NAME1; // return first entry [0]
        } else {
            /* find the correct entry to retrieve */
            int32 ret = xml_strcmp(name, NAME1);
            if (ret < 0) {
                ret_name = NAME1;
            } else if (ret == 0) {
                ret_name = NAME2;
            } else {
                /* check NAME2 */
                ret = xml_strcmp(name, NAME2);
                if (ret < 0) {
                    ret_name = NAME2;
                } else if (ret == 0) {
                    ret_name = NAME3;
                    moreflag = FALSE;
                } else {
                    /* assume NAME3 */
                    ret_name = NAME3;
                    moreflag = FALSE;
                }
            }
        }
    } else {
        if (name) {
            /* get a specified instance */
            boolean name_ok = FALSE;
            if (!xml_strcmp(name, NAME1)) {
                name_ok = TRUE;
            } else if (!xml_strcmp(name, NAME2)) {
                name_ok = TRUE;
            } else if (!xml_strcmp(name, NAME3)) {
                name_ok = TRUE;
                moreflag = FALSE;
            }
            if (name_ok) {
                ret_name = name;
            } else {
                return ERR_NCX_NO_INSTANCE;
            }
        } else {
            // else no keys == get-first
            ret_name = NAME1;
        }
    }

    GETCB_GET2_MATCH_TEST_DONE(get2cb) = FALSE;
    GETCB_GET2_MORE_DATA(get2cb) = moreflag;

    /* if we get here then the index is valid
     *
     * create a return_keyQ node for the name key value
     */
    val_value_t *return_val =
        agt_make_leaf2(obj,
                       y_aio_test_M_aio_test,
                       (const xmlChar *)"name",
                       ret_name,
                       &res);
    if (return_val && res == NO_ERR) {
        getcb_add_return_key(get2cb, return_val);
    } else {
        return res;
    }

    return res;

} /* aio_test_get3_config_cont_config_list_nonconfig_list_get */


/********************************************************************
* FUNCTION aio_test_get3_config_cont_config_list_edit
*
* Edit database object callback
* Path: list /get3-config-cont/config-list
* Add object instrumentation in COMMIT phase.
*
* INPUTS:
*     see agt/agt_cb.h for details
*
* RETURNS:
*     error status
********************************************************************/
static status_t
    aio_test_get3_config_cont_config_list_edit (ses_cb_t *scb,
                                                rpc_msg_t *msg,
                                                agt_cbtyp_t cbtyp,
                                                op_editop_t editop,
                                                val_value_t *newval,
                                                val_value_t *curval)
{
    status_t res = NO_ERR;
    val_value_t *errorval = (curval) ? curval : newval;
    uint32 cur_errs = agt_get_error_count(msg);

    if (LOGDEBUG) {
        log_debug("\nEnter aio_test_get3_config_cont_config_list_edit callback for %s phase",
            agt_cbtype_name(cbtyp));
    }

    switch (cbtyp) {
    case AGT_CB_VALIDATE:
        /* description-stmt validation here */
        break;
    case AGT_CB_APPLY:
        /* database manipulation done here */
        break;
    case AGT_CB_COMMIT:
        /* device instrumentation done here */
        switch (editop) {
        case OP_EDITOP_LOAD:
            break;
        case OP_EDITOP_MERGE:
            break;
        case OP_EDITOP_REPLACE:
            break;
        case OP_EDITOP_CREATE:
            break;
        case OP_EDITOP_DELETE:
            break;
        default:
            res = SET_ERROR(ERR_INTERNAL_VAL);
        }
        break;
    case AGT_CB_ROLLBACK:
        /* undo device instrumentation here */
        break;
    default:
        res = SET_ERROR(ERR_INTERNAL_VAL);
    }

    if ((res != NO_ERR) && (cur_errs == agt_get_error_count(msg))) {
        agt_record_error(
            scb,
            &msg->mhdr,
            NCX_LAYER_CONTENT,
            res,
            NULL,
            (errorval) ? NCX_NT_VAL : NCX_NT_NONE,
            errorval,
            (errorval) ? NCX_NT_VAL : NCX_NT_NONE,
            errorval);
    }
    return res;

} /* aio_test_get3_config_cont_config_list_edit */


/********************************************************************
* FUNCTION aio_test_get3_config_cont_edit
*
* Edit database object callback
* Path: container /get3-config-cont
* Add object instrumentation in COMMIT phase.
*
* INPUTS:
*     see agt/agt_cb.h for details
*
* RETURNS:
*     error status
********************************************************************/
static status_t
    aio_test_get3_config_cont_edit (ses_cb_t *scb,
                                    rpc_msg_t *msg,
                                    agt_cbtyp_t cbtyp,
                                    op_editop_t editop,
                                    val_value_t *newval,
                                    val_value_t *curval)
{
    status_t res = NO_ERR;
    val_value_t *errorval = (curval) ? curval : newval;
    uint32 cur_errs = agt_get_error_count(msg);

    if (LOGDEBUG) {
        log_debug("\nEnter aio_test_get3_config_cont_edit callback for %s phase",
            agt_cbtype_name(cbtyp));
    }

    switch (cbtyp) {
    case AGT_CB_VALIDATE:
        /* description-stmt validation here */
        break;
    case AGT_CB_APPLY:
        /* database manipulation done here */
        break;
    case AGT_CB_COMMIT:
        /* device instrumentation done here */
        switch (editop) {
        case OP_EDITOP_LOAD:
            break;
        case OP_EDITOP_MERGE:
            break;
        case OP_EDITOP_REPLACE:
            break;
        case OP_EDITOP_CREATE:
            break;
        case OP_EDITOP_DELETE:
            break;
        default:
            res = SET_ERROR(ERR_INTERNAL_VAL);
        }

        if (res == NO_ERR) {
            res = agt_check_cache(&get3_config_cont_val, newval, curval, editop);
        }

        break;
    case AGT_CB_ROLLBACK:
        /* undo device instrumentation here */
        break;
    default:
        res = SET_ERROR(ERR_INTERNAL_VAL);
    }

    if ((res != NO_ERR) && (cur_errs == agt_get_error_count(msg))) {
        agt_record_error(
            scb,
            &msg->mhdr,
            NCX_LAYER_CONTENT,
            res,
            NULL,
            (errorval) ? NCX_NT_VAL : NCX_NT_NONE,
            errorval,
            (errorval) ? NCX_NT_VAL : NCX_NT_NONE,
            errorval);
    }
    return res;

} /* aio_test_get3_config_cont_edit */


/********************************************************************
* FUNCTION aio_test_get3_config_cont2_nonconfig_NPcont_get
*
* Get database object callback for container nonconfig-NPcont
* Path: container /get3-config-cont2/nonconfig-NPcont
* Fill in 'get2cb' response fields
*
* sil-aio-get2 extension enabled for this object;
* No callbacks for children will be called
*
* INPUTS:
*     see ncx/getcb.h for details (getcb_fn2_t)
*
* RETURNS:
*     error status
********************************************************************/
static status_t
    aio_test_get3_config_cont2_nonconfig_NPcont_get (ses_cb_t *scb,
                                                     xml_msg_hdr_t *msg,
                                                     getcb_get2_t *get2cb)
{
    if (LOGDEBUG) {
        log_debug("\nEnter aio_test_get3_config_cont2_nonconfig_NPcont_get");
    }

    (void)scb;
    (void)msg;

    /* an NP container always exists so no test for node_exists
     * by the SIL or SIL-SA callback is needed
     */
    obj_template_t *obj = GETCB_GET2_OBJ(get2cb);
    status_t res = NO_ERR;

    /* make return value that will be added to the return_aioQ */
    val_value_t *retval = val_new_value();
    if (!retval) {
        return ERR_INTERNAL_MEM;
    }
    val_init_from_template(retval, obj);

    /* Use retval for the current callback obj and fill
     * it in with folowing terminal and complex nodes;
     * then add to get2cb with help of getcb_add_return_aioQ API
     */
    obj_template_t *childobj =
        getcb_first_requested_child(get2cb, obj);
    for (; childobj; childobj =
        getcb_next_requested_child(get2cb, childobj)) {

        const xmlChar *name = obj_get_name(childobj);

        /* Retrieve the value of this child node and
         * add it to retval of the current callback node
         */
        if (!xml_strcmp(name, (const xmlChar *)"nonconfig-list")) {
            /* list nonconfig-list (list) */

            uint32 key = 0;
            for (key = 1; key < 3; key++) {

                /* create 2 list entries */
                const xmlChar *keyname = NULL;
                if (key == (uint32)1) {
                    keyname = (const xmlChar *)"name1";
                } else if (key == (uint32)2) {
                    keyname = (const xmlChar *)"name2";
                }

                val_value_t *listval =
                    create_list_entry(childobj,
                                      (const xmlChar *)"name",
                                      keyname,
                                      &res);
                if (!listval) {
                    val_free_value(retval);
                    return ERR_INTERNAL_MEM;
                }

                /* Use add_force to allow insertion lists with NO keys */
                res = val_child_add(listval, retval);
                if (res != NO_ERR) {
                    val_free_value(listval);
                    val_free_value(retval);
                    return ERR_NCX_INVALID_VALUE;
                }
            }
        } else if (!xml_strcmp(name, (const xmlChar *)"D")) {
            /* leaf D (int8) */
            val_value_t *child =
                val_make_simval_obj(childobj,
                                    (const xmlChar *)"42",
                                    &res);
            if (child) {
                res = val_child_add(child, retval);
                if (res != NO_ERR) {
                    val_free_value(child);
                    val_free_value(retval);
                    return ERR_NCX_INVALID_VALUE;
                }
            } else {
                val_free_value(retval);
                return ERR_NCX_INVALID_VALUE;
            }
        }
    }

    /* Ensure that the generated value is correct and can be added
     * to the return Queue.
     */
    if (retval && res == NO_ERR) {
        res = val_validate_value(retval);
        if (res != NO_ERR) {
            val_free_value(retval);
            return res;
        }
    }

    /* Add created val_value_t to get2cb with help of
     * getcb_add_return_aioQ API; In case of list callbacks,
     * repeat above steps for another list entry
     */
    getcb_add_return_aioQ(get2cb, retval);

    return res;

} /* aio_test_get3_config_cont2_nonconfig_NPcont_get */


/********************************************************************
* FUNCTION aio_test_get3_config_cont2_edit
*
* Edit database object callback
* Path: container /get3-config-cont2
* Add object instrumentation in COMMIT phase.
*
* INPUTS:
*     see agt/agt_cb.h for details
*
* RETURNS:
*     error status
********************************************************************/
static status_t
    aio_test_get3_config_cont2_edit (ses_cb_t *scb,
                                     rpc_msg_t *msg,
                                     agt_cbtyp_t cbtyp,
                                     op_editop_t editop,
                                     val_value_t *newval,
                                     val_value_t *curval)
{
    status_t res = NO_ERR;
    val_value_t *errorval = (curval) ? curval : newval;
    uint32 cur_errs = agt_get_error_count(msg);

    if (LOGDEBUG) {
        log_debug("\nEnter aio_test_get3_config_cont2_edit callback for %s phase",
            agt_cbtype_name(cbtyp));
    }

    switch (cbtyp) {
    case AGT_CB_VALIDATE:
        /* description-stmt validation here */
        break;
    case AGT_CB_APPLY:
        /* database manipulation done here */
        break;
    case AGT_CB_COMMIT:
        /* device instrumentation done here */
        switch (editop) {
        case OP_EDITOP_LOAD:
            break;
        case OP_EDITOP_MERGE:
            break;
        case OP_EDITOP_REPLACE:
            break;
        case OP_EDITOP_CREATE:
            break;
        case OP_EDITOP_DELETE:
            break;
        default:
            res = SET_ERROR(ERR_INTERNAL_VAL);
        }

        if (res == NO_ERR) {
            res = agt_check_cache(&get3_config_cont2_val, newval, curval, editop);
        }

        break;
    case AGT_CB_ROLLBACK:
        /* undo device instrumentation here */
        break;
    default:
        res = SET_ERROR(ERR_INTERNAL_VAL);
    }

    if ((res != NO_ERR) && (cur_errs == agt_get_error_count(msg))) {
        agt_record_error(
            scb,
            &msg->mhdr,
            NCX_LAYER_CONTENT,
            res,
            NULL,
            (errorval) ? NCX_NT_VAL : NCX_NT_NONE,
            errorval,
            (errorval) ? NCX_NT_VAL : NCX_NT_NONE,
            errorval);
    }
    return res;

} /* aio_test_get3_config_cont2_edit */


/********************************************************************
* FUNCTION y_aio_test_init
*
* initialize the aio-test server instrumentation library
*
* INPUTS:
*    modname == requested module name
*    revision == requested version (NULL for any)
*
* RETURNS:
*     error status
********************************************************************/
status_t y_aio_test_init (
    const xmlChar *modname,
    const xmlChar *revision)
{
    status_t res = NO_ERR;

    y_aio_test_init_static_vars();

    /* change if custom handling done */
    if (xml_strcmp(modname, y_aio_test_M_aio_test)) {
        return ERR_NCX_UNKNOWN_MODULE;
    }

    if (revision && xml_strcmp(revision, y_aio_test_R_aio_test)) {
        return ERR_NCX_WRONG_VERSION;
    }

    res = ncxmod_load_module(
        y_aio_test_M_aio_test,
        y_aio_test_R_aio_test,
        agt_get_savedevQ(),
        &aio_test_mod);
    if (res != NO_ERR) {
        return res;
    }

    get3_config_cont_obj = ncx_find_object(
        aio_test_mod,
        y_aio_test_N_get3_config_cont);
    if (get3_config_cont_obj == NULL) {
        return ERR_NCX_DEF_NOT_FOUND;
    }

    get3_config_cont2_obj = ncx_find_object(
        aio_test_mod,
        y_aio_test_N_get3_config_cont2);
    if (get3_config_cont2_obj == NULL) {
        return ERR_NCX_DEF_NOT_FOUND;
    }

    res = agt_cb_register_edit2_callback(
        y_aio_test_M_aio_test,
        (const xmlChar *)"/aiotest:get3-config-cont",
        y_aio_test_R_aio_test,
        aio_test_get3_config_cont_edit);
    if (res != NO_ERR) {
        return res;
    }

    res = agt_cb_register_edit2_callback(
        y_aio_test_M_aio_test,
        (const xmlChar *)"/aiotest:get3-config-cont/aiotest:config-list",
        y_aio_test_R_aio_test,
        aio_test_get3_config_cont_config_list_edit);
    if (res != NO_ERR) {
        return res;
    }

    res = agt_cb_register_get_callback(
        y_aio_test_M_aio_test,
        (const xmlChar *)"/aiotest:get3-config-cont/aiotest:config-list/aiotest:nonconfig-list",
        y_aio_test_R_aio_test,
        aio_test_get3_config_cont_config_list_nonconfig_list_get);
    if (res != NO_ERR) {
        return res;
    }

    res = agt_cb_register_get_callback(
        y_aio_test_M_aio_test,
        (const xmlChar *)"/aiotest:get3-config-cont/aiotest:config-list/aiotest:nonconfig-list/aiotest:nonconfig-list2",
        y_aio_test_R_aio_test,
        aio_test_get3_config_cont_config_list_nonconfig_list_nonconfig_list2_get);
    if (res != NO_ERR) {
        return res;
    }

    res = agt_cb_register_edit2_callback(
        y_aio_test_M_aio_test,
        (const xmlChar *)"/aiotest:get3-config-cont2",
        y_aio_test_R_aio_test,
        aio_test_get3_config_cont2_edit);
    if (res != NO_ERR) {
        return res;
    }

    res = agt_cb_register_get_callback(
        y_aio_test_M_aio_test,
        (const xmlChar *)"/aiotest:get3-config-cont2/aiotest:nonconfig-NPcont",
        y_aio_test_R_aio_test,
        aio_test_get3_config_cont2_nonconfig_NPcont_get);
    if (res != NO_ERR) {
        return res;
    }

    /* put your module initialization code here */

    return res;

} /* y_aio_test_init */

/********************************************************************
* FUNCTION y_aio_test_init2
*
* SIL init phase 2: non-config data structures
* Called after running config is loaded
*
* RETURNS:
*     error status
********************************************************************/
status_t y_aio_test_init2 (void)
{
    status_t res = NO_ERR;

    get3_config_cont_val = agt_init_cache(
        y_aio_test_M_aio_test,
        y_aio_test_N_get3_config_cont,
        &res);
    if (res != NO_ERR) {
        return res;
    }

    get3_config_cont2_val = agt_init_cache(
        y_aio_test_M_aio_test,
        y_aio_test_N_get3_config_cont2,
        &res);
    if (res != NO_ERR) {
        return res;
    }

    /* put your init2 code here */

    return res;

} /* y_aio_test_init2 */

/********************************************************************
* FUNCTION y_aio_test_cleanup
*    cleanup the server instrumentation library
*
********************************************************************/
void y_aio_test_cleanup (void)
{

    agt_cb_unregister_callbacks(
        y_aio_test_M_aio_test,
        (const xmlChar *)"/aiotest:get3-config-cont");

    agt_cb_unregister_callbacks(
        y_aio_test_M_aio_test,
        (const xmlChar *)"/aiotest:get3-config-cont/aiotest:config-list");

    agt_cb_unregister_callbacks(
        y_aio_test_M_aio_test,
        (const xmlChar *)"/aiotest:get3-config-cont/aiotest:config-list/aiotest:nonconfig-list");

    agt_cb_unregister_callbacks(
        y_aio_test_M_aio_test,
        (const xmlChar *)"/aiotest:get3-config-cont/aiotest:config-list/aiotest:nonconfig-list/aiotest:nonconfig-list2");

    agt_cb_unregister_callbacks(
        y_aio_test_M_aio_test,
        (const xmlChar *)"/aiotest:get3-config-cont2");

    agt_cb_unregister_callbacks(
        y_aio_test_M_aio_test,
        (const xmlChar *)"/aiotest:get3-config-cont2/aiotest:nonconfig-NPcont");

    /* put your cleanup code here */

} /* y_aio_test_cleanup */

/* END SIL aio_test.c */
